$(document).ready(function() {
  $('.image').each(function() {
	// "Add a note" button
	var button = '';
	button += '<div class="image-annotate-add-button">' + Drupal.t('Add a note') + '</div>';
	$(this).before(button);
	$('.image-annotate-add-button').click(image_annotate_add_note);
	
	// Hide the image and replace it by a div with right background and size
	IA_settings.width = $(this).attr('width');
	IA_settings.height = $(this).attr('height');
	
    $('.image').after('<div id="image-annotate-wrapper"></div>');
    $('#image-annotate-wrapper').css('background', 'transparent url(' + $('.image').attr('src') + ') no-repeat scroll 0px 0px');
    $('#image-annotate-wrapper').css( { width: IA_settings.width +'px', height: IA_settings.height +'px' } );
    $('.image').hide();
	
    // Load the overall html code for the notes
    $('#image-annotate-wrapper').load('/image-annotate/view-canvas', {}, function() { 
	  $('#image-annotate-edit').css( { width: IA_settings.width +'px', height: IA_settings.height +'px' } );
	  $('#image-annotate-view').css( { width: IA_settings.width +'px', height: IA_settings.height +'px' } );
	  
	  // Initialize the region selector
	  image_annotate_initialize_note_edit();
	  
	  // Shows notes when hovered
	  $('#image-annotate-wrapper').hover(
        function() {
          if (!IA_settings.edit) $('#image-annotate-view').show();
        },
        function() {
          if (!IA_settings.edit) $('#image-annotate-view').hide();
        }
      );
	  
	  // Load the notes
      $('#image-annotate-view').load('/image-annotate/view-notes', {vid: IA_settings.vid}, image_annotate_intialize_notes);
      image_annotate_intialize_notes();
	
      // Retrieve the border widths
      IA_settings.border = new Object;
	
      IA_settings.border.outer = new Object;
	  IA_settings.border.outer.top = parseInt($('#image-annotate-edit .image-annotate-frame').css('borderTopWidth'));
	  IA_settings.border.outer.right = parseInt($('#image-annotate-edit .image-annotate-frame').css('borderRightWidth'));
	  IA_settings.border.outer.bottom = parseInt($('#image-annotate-edit .image-annotate-frame').css('borderBottomWidth'));
	  IA_settings.border.outer.left = parseInt($('#image-annotate-edit .image-annotate-frame').css('borderLeftWidth'));
	
      IA_settings.border.inner = new Object;
	  IA_settings.border.inner.top = parseInt($('#image-annotate-edit .image-annotate-innerframe').css('borderTopWidth'));
	  IA_settings.border.inner.right = parseInt($('#image-annotate-edit .image-annotate-innerframe').css('borderRightWidth'));
	  IA_settings.border.inner.bottom = parseInt($('#image-annotate-edit .image-annotate-innerframe').css('borderBottomWidth'));
	  IA_settings.border.inner.left = parseInt($('#image-annotate-edit .image-annotate-innerframe').css('borderLeftWidth'));
	});
  });
});

function image_annotate_add_note() {
  var css = {
    top: '',
    left: '',
    height: '',
    width: ''
  };
  
  $('#image-annotate-edit').css(css);
  $('#image-annotate-edit .image-annotate-frame').css(css);
  $('#image-annotate-edit .image-annotate-innerframe').css(css);
  $('#image-annotate-edit .image-annotate-text').css(css);
  $('#image-annotate-edit').show();
  IA_settings.aid = 0;
  IA_settings.edit = true;
  $('#image-annotate-view').show();
}

function image_annotate_intialize_notes() {
  $('#image-annotate-view .image-annotate-frame').click(function() {
    var note = new Object;
    note.top = parseInt($(this).parent().css('top').replace('px', ''));
    note.left = parseInt($(this).parent().css('left').replace('px', ''));
    note.width =  $(this).width();
    note.height = $(this).height();
    note.text = $(this).siblings('div.image-annotate-text').children('p').children('span').text();
	
	$('#image-annotate-edit .image-annotate-frame').css({
      left: note.left,
      top: note.top,
      width: note.width,
      height: note.height
    });
	
	$('#image-annotate-edit .image-annotate-innerframe').css({
      left: 0,
      top: 0,
      width: note.width - (IA_settings.border.outer.left + IA_settings.border.outer.right),
      height: note.height - (IA_settings.border.outer.top + IA_settings.border.outer.bottom)
    });
	
	$('#image-annotate-edit textarea').val(note.text);
	
	$('#image-annotate-edit .image-annotate-text').css({
      left: note.left,
      top: IA_settings.editMargin + note.height + note.top
    });
	
	IA_settings.aid = parseInt($(this).parent().attr('id').replace('image-annotate-note-', ''));
    IA_settings.edit = true;
	$('#image-annotate-view').show();
	$(this).parent().hide();
	$('#image-annotate-edit').show();
  });
  $('#image-annotate-view .image-annotate-note').hover(
    function() {
      if (!IA_settings.edit) $(this).children('.image-annotate-text').show();
    },
	function() {
      $(this).children('.image-annotate-text').hide();
    }
  );
}

function image_annotate_initialize_note_edit() {
  IA_settings.editMargin = parseInt($('#image-annotate-edit .image-annotate-text').css('top')) - ($('#image-annotate-edit .image-annotate-frame').height() + parseInt($('#image-annotate-edit .image-annotate-frame').css('top')));
  $('#image-annotate-edit').hide();
  $('#image-annotate-edit input.cancel').click(function(){
    $('#image-annotate-edit').hide();
	IA_settings.edit = false;
	if (IA_settings.aid) $('#image-annotate-note-'+ IA_settings.aid).show();
	return false;
  });
  
  $('#image-annotate-edit  input.save').click(function(){
  	var note = new Object;
    note.top = parseInt($('#image-annotate-edit .image-annotate-frame').css('top'));
    note.left = parseInt($('#image-annotate-edit .image-annotate-frame').css('left'));
	note.height = parseInt($('#image-annotate-edit .image-annotate-frame').height());
    note.width = parseInt($('#image-annotate-edit .image-annotate-frame').width());
    note.text = $('#image-annotate-edit textarea').val();
	var data = {
	  top: note.top,
      left: note.left,
      height: note.height,
      width: note.width,
      note: note.text
    };
    if (IA_settings.aid) {
      data.aid = IA_settings.aid;
      var url = '/image-annotate/edit'; 
	}
	else {
      data.vid = IA_settings.vid;
	  var url = '/image-annotate/create';
	}
    $.ajax({
      url: url,
      type: 'GET',
      data: data,
      dataType: 'json',
      timeout: 100000,
      error: function(){
        alert(Drupal.t('Could not save the note'));
        IA_settings.edit = false;
      },
      success: function (data, textStatus) {
        IA_settings.edit = false;
        $('#image-annotate-edit').hide();
        $('#image-annotate-view').load('/image-annotate/view-notes', {vid: IA_settings.vid}, image_annotate_intialize_notes);
        image_annotate_intialize_notes();
        return false;
      }
    });
	return false;
  });
  
  $('#image-annotate-edit input.delete').click(function() {
    $.ajax({
      url: '/image-annotate/delete',
      type: 'GET',
      data: data = {aid: IA_settings.aid},
      dataType: 'json',
      timeout: 100000,
      error: function(){
        alert(Drupal.t('Could not delete the note'));
		IA_settings.edit = false;
      },
      success: function (data, textStatus) {
        IA_settings.edit = false;
		$('#image-annotate-edit').hide();
        $('#image-annotate-view').load('/image-annotate/view-notes', {vid: IA_settings.vid}, image_annotate_intialize_notes);
	    image_annotate_intialize_notes();
		return false;
      }
    });
  });
  
  $('#image-annotate-edit form').submit(function(){return false;})
  
  // Define the resizable area
  $('#image-annotate-edit .image-annotate-innerframe').resizable({
    handles: 'all',
    knobHandles: true,
    containment: $('#image-annotate-view'),
	start: function(e, ui) {
      IA_settings.top = parseInt($('#image-annotate-edit .image-annotate-frame').css('top'));
    },
	resize: function(e, ui) {image_annotate_resize_update('resize')},
	stop: function(e, ui) {image_annotate_resize_update('stop')}
  });
  
  // Define the draggable area
  $('#image-annotate-edit .image-annotate-frame').draggable({
    containment: $('#image-annotate-view'),
	drag: function(e, ui) {image_annotate_drag_update()},
	stop: function(e, ui) {image_annotate_drag_update()}
  });
}

function image_annotate_drag_update() {
  $('#image-annotate-edit .image-annotate-text').css({
    left: parseInt($('#image-annotate-edit .image-annotate-frame').css('left')),
    top: IA_settings.editMargin + $('#image-annotate-edit .image-annotate-frame').height() + parseInt($('#image-annotate-edit .image-annotate-frame').css('top'))
  });
}

function image_annotate_resize_update(event) {
  var note = new Object;
  note.top = parseInt($('#image-annotate-edit .image-annotate-frame').css('top')) + parseInt($('#image-annotate-edit .image-annotate-innerframe').css('top'));
  note.left = parseInt($('#image-annotate-edit .image-annotate-frame').css('left')) + parseInt($('#image-annotate-edit .image-annotate-innerframe').css('left'));
  note.height = parseInt($('#image-annotate-edit .image-annotate-innerframe').css('height')) + IA_settings.border.inner.top + IA_settings.border.inner.bottom;
  note.width = parseInt($('#image-annotate-edit .image-annotate-innerframe').css('width')) + IA_settings.border.inner.left + IA_settings.border.inner.right;

  if (note.top < 0) {
    note.height = note.height + note.top;
    note.top = 0;
  }
  if (note.left < 0) {
    note.width = note.width + note.left;
    note.left = 0;
  }
  if (note.top + note.height > IA_settings.height) {
    note.height = IA_settings.height - note.top - IA_settings.border.inner.bottom - IA_settings.border.outer.bottom;
  }
  if (note.left + note.width > IA_settings.width) {
    note.width = IA_settings.width - note.left - IA_settings.border.inner.right - IA_settings.border.outer.right;
  }
  
  if (event == 'stop') {
    $('#image-annotate-edit .image-annotate-frame').css({
      height: note.height,
      width: note.width,
      top: note.top,
      left: note.left
    });
  
    $('#image-annotate-edit .image-annotate-innerframe').css({
      height: note.height - (IA_settings.border.outer.top + IA_settings.border.outer.bottom),
      width: note.width - (IA_settings.border.outer.left + IA_settings.border.outer.right),
      top: 0,
      left: 0
    });
  }
  
  if (parseInt($('#image-annotate-edit .image-annotate-frame').css('top')) == IA_settings.top) {
    $('#image-annotate-edit .image-annotate-text').css({
      left: note.left,
      top: IA_settings.editMargin + note.height + note.top
    });
  }
}